---
title: Create Variable Definition
slug: feature-experimentation/api/create-variable-definition
docTags: 
createdAt: 2026-08-28T15:54:06.731Z
---

{
  "id": "wrs3o_qcRtdCWl5_x_O_K",
  "type": "api-oas-v2",
  "data": {
    "method": "POST",
    "url": "https://api.optimizely.com/flags/v1//projects/{project_id}/flags/{flag_key}/variable_definitions",
    "servers": [
      {
        "url": "https://api.optimizely.com/flags/v1//projects/{project_id}/flags/{flag_key}/variable_definitions"
      }
    ],
    "name": "Create Variable Definition",
    "description": "Create Variable Definition\n",
    "contentType": "application/json",
    "request": {
      "pathParameters": [
        {
          "kind": "required",
          "name": "flag_key",
          "type": "string",
          "example": "recurring_deposit",
          "description": "The Flag identifier"
        },
        {
          "kind": "required",
          "name": "project_id",
          "type": "integer",
          "example": 12345,
          "description": "The project identifier"
        }
      ],
      "headerParameters": [
        {
          "name": "accept",
          "type": "string",
          "kind": "optional",
          "description": "Generated from available response content types",
          "enum": [
            "application/json"
          ],
          "default": "application/json"
        }
      ],
      "queryParameters": [],
      "bodyDataParameters": [
        {
          "kind": "required",
          "name": "body",
          "type": "object",
          "example": "{\"default_value\":\"my_default_str\",\"description\":\"some description\",\"key\":\"variable_definition_key\",\"type\":\"string\"}",
          "description": "",
          "customType": "VariableDefinition",
          "schema": [
            {
              "name": "default_value",
              "kind": "required",
              "type": "string",
              "description": "The default value for the Flag Variable Definition",
              "example": "0.0"
            },
            {
              "name": "description",
              "kind": "optional",
              "type": "string",
              "description": "Additional context of the Flag Variable Definition",
              "example": "This variable is used to configure the amount used for computing the discount"
            },
            {
              "name": "key",
              "kind": "required",
              "type": "string",
              "description": "Unique string identifier for the Flag Variable Definition within the Flag",
              "example": "amount"
            },
            {
              "name": "type",
              "kind": "required",
              "type": "string<boolean | string | double | integer | json>",
              "description": "The datatype for the Flag Variable Definition",
              "example": "double",
              "enum": [
                "boolean",
                "string",
                "double",
                "integer",
                "json"
              ]
            }
          ],
          "modelRef": "#/components/schemas/VariableDefinition",
          "isExpanded": true
        }
      ],
      "formDataParameters": [],
      "oAuthParameters": [
        {
          "id": "apiKey",
          "name": "apiKey",
          "kind": "optional",
          "type": "http",
          "scheme": "bearer"
        },
        {
          "id": "OAuth2",
          "name": "OAuth2",
          "kind": "optional",
          "type": "oauth2",
          "description": "Write applications that authenticate with the REST API via OAuth 2.0.",
          "oauth2Flows": {
            "authorizationCode": {
              "authorizationUrl": "https://app.optimizely.com/oauth2/authorize",
              "tokenUrl": "https://app.optimizely.com/oauth2/token",
              "scopes": {
                "all": "Grants all access"
              }
            }
          },
          "requiredScopes": [
            "read",
            "write"
          ]
        }
      ],
      "cookieParameters": []
    },
    "responses": [
      {
        "statusCode": "200",
        "description": "Create a variable definition\n",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "example": "{\"default_value\":\"my_default_str\",\"description\":\"some description\",\"key\":\"variable_definition_key\",\"type\":\"string\"}",
            "description": "",
            "customType": "VariableDefinition",
            "schema": [
              {
                "name": "default_value",
                "kind": "required",
                "type": "string",
                "description": "The default value for the Flag Variable Definition",
                "example": "0.0"
              },
              {
                "name": "description",
                "kind": "optional",
                "type": "string",
                "description": "Additional context of the Flag Variable Definition",
                "example": "This variable is used to configure the amount used for computing the discount"
              },
              {
                "name": "key",
                "kind": "required",
                "type": "string",
                "description": "Unique string identifier for the Flag Variable Definition within the Flag",
                "example": "amount"
              },
              {
                "name": "revision",
                "kind": "optional",
                "type": "integer",
                "readOnly": true,
                "description": "Revision number for tracking changes"
              },
              {
                "name": "role",
                "kind": "optional",
                "type": "string",
                "readOnly": true,
                "description": "Granular permission role",
                "example": "admin"
              },
              {
                "name": "type",
                "kind": "required",
                "type": "string<boolean | string | double | integer | json>",
                "description": "The datatype for the Flag Variable Definition",
                "example": "double",
                "enum": [
                  "boolean",
                  "string",
                  "double",
                  "integer",
                  "json"
                ]
              }
            ],
            "modelRef": "#/components/schemas/VariableDefinition",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "400",
        "description": "Malformed requests and invalid parameter names and types",
        "jsonExample": "",
        "isExpanded": true
      },
      {
        "statusCode": "401",
        "description": "Invalid credentials",
        "jsonExample": "",
        "isExpanded": true
      },
      {
        "statusCode": "403",
        "description": "Do not have permission to perform the operation",
        "jsonExample": "",
        "isExpanded": true
      },
      {
        "statusCode": "404",
        "description": "Not found. No content",
        "jsonExample": "",
        "isExpanded": true
      },
      {
        "statusCode": "409",
        "description": "Conflicting resource state with requested action",
        "jsonExample": "",
        "isExpanded": true
      }
    ],
    "hasXCodeSamples": false,
    "examples": {
      "languages": [
        {
          "id": "Pdxf-Y61yQ75g26pJQTCk",
          "language": "curl",
          "label": "cURL",
          "code": "curl --request POST \\\n     --url https://api.optimizely.com/flags/v1//projects/{project_id}/flags/{flag_key}/variable_definitions \\\n     --header 'accept: application/json' \\\n     --header 'content-type: application/json' \\\n     --data '{\n     \"default_value\": \"0.0\",\n     \"key\": \"amount\",\n     \"type\": \"double\"\n     }'"
        },
        {
          "id": "nQCh7VSSbury2hYnMqlmn",
          "language": "javascript",
          "label": "javascript",
          "code": "var myHeaders = new Headers();\nmyHeaders.append(\"accept\", \"application/json\");\nmyHeaders.append(\"content-type\", \"application/json\");\n\nvar raw = JSON.stringify({\n   \"default_value\": \"0.0\",\n   \"key\": \"amount\",\n   \"type\": \"double\"\n});\n\nvar requestOptions = {\n   method: 'POST',\n   headers: myHeaders,\n   body: raw,\n   redirect: 'follow'\n};\n\nfetch(\"https://api.optimizely.com/flags/v1//projects/{project_id}/flags/{flag_key}/variable_definitions\", requestOptions)\n   .then(response => response.text())\n   .then(result => console.log(result))\n   .catch(error => console.log('error', error));"
        },
        {
          "id": "jXWukgz4UrPu0kKnx4zv2",
          "language": "ruby",
          "label": "Ruby",
          "code": "require \"uri\"\nrequire \"json\"\nrequire \"net/http\"\n\nurl = URI(\"https://api.optimizely.com/flags/v1//projects/{project_id}/flags/{flag_key}/variable_definitions\")\n\nhttps = Net::HTTP.new(url.host, url.port)\nhttps.use_ssl = true\n\nrequest = Net::HTTP::Post.new(url)\nrequest[\"accept\"] = \"application/json\"\nrequest[\"content-type\"] = \"application/json\"\nrequest.body = JSON.dump({\n   \"default_value\": \"0.0\",\n   \"key\": \"amount\",\n   \"type\": \"double\"\n})\n\nresponse = https.request(request)\nputs response.read_body\n"
        },
        {
          "id": "djq97vLTXyxUhupeW1okQ",
          "language": "python",
          "label": "Python",
          "code": "import requests\nimport json\n\nurl = \"https://api.optimizely.com/flags/v1//projects/{project_id}/flags/{flag_key}/variable_definitions\"\n\npayload = json.dumps({\n   \"default_value\": \"0.0\",\n   \"key\": \"amount\",\n   \"type\": \"double\"\n})\nheaders = {\n   'accept': 'application/json',\n   'content-type': 'application/json'\n}\n\nresponse = requests.request(\"POST\", url, headers=headers, data=payload)\n\nprint(response.text)\n"
        }
      ],
      "selectedLanguageId": "Pdxf-Y61yQ75g26pJQTCk"
    },
    "results": {
      "languages": [
        {
          "id": "response-0-200",
          "language": "200",
          "code": "// Create a variable definition\n{\n  \"default_value\": \"0.0\",\n  \"description\": \"This variable is used to configure the amount used for computing the discount\",\n  \"key\": \"amount\",\n  \"revision\": 0,\n  \"role\": \"admin\",\n  \"type\": \"double\"\n}"
        },
        {
          "id": "response-1-400",
          "language": "400",
          "code": "// Malformed requests and invalid parameter names and types\n"
        },
        {
          "id": "response-2-401",
          "language": "401",
          "code": "// Invalid credentials\n"
        },
        {
          "id": "response-3-403",
          "language": "403",
          "code": "// Do not have permission to perform the operation\n"
        },
        {
          "id": "response-4-404",
          "language": "404",
          "code": "// Not found. No content\n"
        },
        {
          "id": "response-5-409",
          "language": "409",
          "code": "// Conflicting resource state with requested action\n"
        }
      ],
      "selectedLanguageId": "response-0-200"
    }
  },
  "children": [
    {
      "text": ""
    }
  ]
}